<sqtm-core-customisable-dialog
  [titleKey]="
    'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.title'
  "
  [dialogId]="'ai-generate-test-cases'"
  (confirm)="confirm()"
>
  <sqtm-core-dialog-body>
    <div class="generate-ct-grid m-x-8 m-t-5 overflow-hidden">
      <div class="flex-column m-r-15">
        <div>
          <label class="label-color p-5 txt__semi-bold">
            {{
              'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.requirement-description'
                | translate
            }}
          </label>
          <div class="full-height requirement m-t-5">
            <sqtm-core-editable-rich-text
              [editable]="false"
              [attr.data-test-field-id]="'requirement-description'"
              [value]="componentData.requirementVersion.description"
            >
            </sqtm-core-editable-rich-text>
          </div>

          <div class="flex full-width justify-content-flex-end m-t-10">
            <button
              #generateButton
              class="ant-btn ant-btn-primary flex-row"
              nz-button
              [attr.data-test-button-id]="'generate-test-cases'"
              [nzLoading]="isLoading$ | async"
              (click)="sendApiRequest()"
            >
              {{
                'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.generate'
                  | translate
              }}
            </button>
          </div>
          <div class="m-t-5 flex align-center">
            <i
              nz-icon
              nzType="sqtm-core-nav:test-case-workspace"
              nzTheme="outline"
              class="font-20-px m-r-10 icon-tree-picker-color"
            ></i>
            <a
              [attr.data-test-element-id]="'pick-destination'"
              (click)="openTreePicker()"
            >
              {{
                'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.pick-folder'
                  | translate
              }}
            </a>
          </div>
          @if (this.destinationFolderPath$()) {
            <div class="flex">
              <span
                class="m-t-15 m-l-30 txt-ellipsis"
                nz-tooltip
                [attr.data-test-element-id]="'destination-path'"
                [sqtmCoreLabelTooltip]="this.destinationFolderPath$()"
              >
                {{ this.destinationFolderPath$() }}
              </span>
            </div>
          }
        </div>
      </div>
      <div class="flex-column">
        <div class="m-l-20 m-r-5 full-height">
          <label class="label-color m-l-5 p-5 txt__semi-bold">
            {{
              'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.generated-test-cases'
                | translate
            }}
          </label>
          @if (this.errorFromServer$()) {
            <div class="full-height align-content-center">
              <span
                class="text-align-center error-color display-block p-x-60"
                [innerHTML]="
                  'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.error.generation-failed'
                    | translate
                "
              >
              </span>
            </div>
          } @else {
            @if (testCasesDisplayData !== []) {
              <div class="m-t-20">
                @for (testCase of testCasesDisplayData; track testCase.name) {
                  <sqtm-app-generated-test-case-foldable-row
                    [attr.data-test-element-id]="testCase.name"
                    [testCase]="testCase"
                    (isTestCaseSelected)="updateTestCaseSelection(testCase)"
                  >
                  </sqtm-app-generated-test-case-foldable-row>
                }
              </div>
            }
          }
        </div>
      </div>
    </div>
  </sqtm-core-dialog-body>
  <sqtm-core-dialog-footer class="m-t-10 flex">
    <div class="align-self-end">
      @if (shouldDisplayNoTestCaseSelectedError$()) {
        <span
          [attr.data-test-element-id]="'no-test-case-selected'"
          class="m-r-10 error-color"
        >
          {{
            'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.error.no-test-case-selected'
              | translate
          }}
        </span>
      } @else if (shouldDisplayNoFolderSelectedError$()) {
        <span
          [attr.data-test-element-id]="'no-destination-selected'"
          class="m-r-10 error-color"
        >
          {{
            'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.error.no-folder-selected'
              | translate
          }}
        </span>
      }
    </div>
    <button
      [attr.data-test-dialog-button-id]="'confirm'"
      [disabled]="!this.isTestCaseGenerated$()"
      class="flex-fixed-size ant-btn-primary"
      nz-button
      nzType="primary"
      (click)="confirm()"
    >
      {{
        'sqtm-core.requirement-workspace.dialog.artificial-intelligence.generate-test-case.record-test-cases'
          | translate
      }}
    </button>
    <button
      [attr.data-test-dialog-button-id]="'cancel'"
      class="flex-fixed-size m-l-10"
      nz-button
      nzType="default"
      sqtmCoreDialogClose
    >
      {{ 'sqtm-core.generic.label.cancel' | translate }}
    </button>
  </sqtm-core-dialog-footer>
</sqtm-core-customisable-dialog>
